!= Module FileSet
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: fileset.f90,v 1.2 2006/09/21 02:41:52 odakker Exp $ 
! Tag Name::  $Name: arare4-20060922 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!引数に与えられた NAMELIST ファイルから, ファイル名や表題等の情報を取得し
!保管するための変数型モジュール
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module fileset
  !
  !引数に与えられた NAMELIST ファイルから, I/O ファイル名を取得し, 
  !保管するための変数型モジュール
  !

  !暗黙の型宣言禁止
  implicit none

  !save 属性
  save

  !公開変数
  character(80) :: InitFile          !初期値ファイル
  character(80) :: HistoryFile       !ヒストリーファイル
  character(80) :: ReStartFile       !リスタートファイル
  character(80) :: RandomFile        !乱数ファイル
  character(80) :: ExpTitle          !データの表題
  character(80) :: ExpSrc            !データを作成する手順
  character(80) :: ExpInst           !最終変更者・組織

contains

  subroutine fileset_init(cfgfile)
    !
    !NAMELIST からファイル名に付けるタグを得て, 出力ファイル名を作成する. 
    !

    !モジュール読み込み
    use dc_message,    only: MessageNotify

    !暗黙の型宣言禁止
    implicit none

    !入力変数
    character(*), intent(in) :: cfgfile

    !NAMELIST から情報を取得
    NAMELIST /fileset/                                  &
      & InitFile, HistoryFile, ReStartFile, RandomFile, &
      & ExpTitle, ExpSrc,      ExpInst

    open (10, FILE=cfgfile)
    read(10, NML=fileset)
    close(10)

    !確認
    call MessageNotify("Message", "fileset_init, InitFile   ", InitFile)
    call MessageNotify("Message", "fileset_init, HistoryFile", HistoryFile)
    call MessageNotify("Message", "fileset_init, ReStartFile", ReStartFile)
    call MessageNotify("Message", "fileset_init, RandomFile ", RandomFile)
    call MessageNotify("Message", "fileset_init, ExpTitle   ", ExpTitle)
    call MessageNotify("Message", "fileset_init, ExpSrc     ", ExpSrc)
    call MessageNotify("Message", "fileset_init, ExpInst    ", ExpInst)
    
  end subroutine fileset_init
end module fileset
